program matrix
  implicit none
  integer :: m_min, m_int, m_max 
  integer :: n_min, n_int, n_max 
  integer :: inc
  character(len=256) :: key

  call getarg(1,key); read(key,*)m_min
  call getarg(2,key); read(key,*)m_int
  call getarg(3,key); read(key,*)m_max
  call getarg(4,key); read(key,*)n_min
  call getarg(5,key); read(key,*)n_int
  call getarg(6,key); read(key,*)n_max
  call getarg(7,key); read(key,*)inc

  call dgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
!  call sgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
!  call hgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
!  call zgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
!  call cgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)

end

!-------------------------------------------------------------------------------
subroutine dgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
  implicit none
  integer, intent(in) :: m_min, m_int, m_max, n_min, n_int, n_max, inc
  integer :: m, n
  real(8) :: flop, t1, t2

  do m = m_min, m_max, m_int
     n=m
!     do n = n_min, n_max, n_int
        call dgemv_time(m, n, t1, t2, inc)
        flop=dble(m)*dble(n+2) + dble(m)*dble(n)
        write(0,300) m,n, &
             flop/t1 /dble(1000)**4, &
             flop/t2 /dble(1000)**4, &
             flop, t1, t2
!     enddo
  enddo
  
300  format (1x,"dgemv",i6,i6,2(1x,f8.5),1x,e12.5 ,2(1x,e12.5))  
end 

!-------------------------------------------------------------------------------
subroutine sgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
  implicit none
  integer, intent(in) :: m_min, m_int, m_max, n_min, n_int, n_max, inc
  integer :: m, n
  real(8) :: flop, t1, t2

  do m = m_min, m_max, m_int
     n=m
!     do n = n_min, n_max, n_int
        call sgemv_time(m, n, t1, t2, inc)
        flop=dble(m)*dble(n+2) + dble(m)*dble(n)
        write(0,300) m,n, &
             flop/t1 /dble(1000)**4, &
             flop/t2 /dble(1000)**4, &
             flop, t1, t2
!     enddo
  enddo
  
300  format (1x,"sgemv",i6,i6,2(1x,f8.5),1x,e12.5 ,2(1x,e12.5))  
end 

!-------------------------------------------------------------------------------
subroutine hgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
  implicit none
  integer, intent(in) :: m_min, m_int, m_max, n_min, n_int, n_max, inc
  integer :: m, n
  real(8) :: flop, t1, t2

  do m = m_min, m_max, m_int
     n=m
!     do n = n_min, n_max, n_int
        call hgemv_time(m, n, t1, t2, inc)
        flop=dble(m)*dble(n+2) + dble(m)*dble(n)
        write(0,300) m,n, &
             flop/t1 /dble(1000)**4, &
             flop/t2 /dble(1000)**4, &
             flop, t1, t2
!     enddo
  enddo
  
300  format (1x,"hgemv",i6,i6,2(1x,f8.5),1x,e12.5 ,2(1x,e12.5))  
end

!-------------------------------------------------------------------------------
subroutine zgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
  implicit none
  integer, intent(in) :: m_min, m_int, m_max, n_min, n_int, n_max, inc
  integer :: m, n
  real(8) :: flop, t1, t2

  do m = m_min, m_max, m_int
     n=m
!     do n = n_min, n_max, n_int
        call zgemv_time(m, n, t1, t2, inc)
        flop=dble(m)*dble(n+2)*dble(6) + dble(m)*dble(n)*dble(2)
        write(0,300) m,n, &
             flop/t1 /dble(1000)**4, &
             flop/t2 /dble(1000)**4, &
             flop, t1, t2
!     enddo
  enddo
  
300  format (1x,"zgemv",i6,i6,2(1x,f8.5),1x,e12.5 ,2(1x,e12.5))  
end

!-------------------------------------------------------------------------------
subroutine cgemv_all(m_min, m_int, m_max, n_min, n_int, n_max, inc)
  implicit none
  integer, intent(in) :: m_min, m_int, m_max, n_min, n_int, n_max, inc
  integer :: m, n
  real(8) :: flop, t1, t2

  do m = m_min, m_max, m_int
     n=m
!     do n = n_min, n_max, n_int
        call cgemv_time(m, n, t1, t2, inc)
        flop=dble(m)*dble(n+2)*dble(6) + dble(m)*dble(n)*dble(2)
        write(0,300) m,n, &
             flop/t1 /dble(1000)**4, &
             flop/t2 /dble(1000)**4, &
             flop, t1, t2
!     enddo
  enddo
  
300  format (1x,"cgemv",i6,i6,2(1x,f8.5),1x,e12.5 ,2(1x,e12.5))  
end 

!-------------------------------------------------------------------------------
subroutine dgemv_time(m,n,t1,t2, inc)
  implicit none
  integer, parameter :: imax=20000
  integer, intent(in) :: m, n, inc
  real(8) :: a(imax,imax), x(imax), y(imax)
  real(8) :: alpha, beta
  integer :: lda, ldat, incx, incy,i
  real(8) :: t0, t1, t2
  real(8), external :: seconds

  alpha = 2.0
  beta  = 1.0
  lda = m
  ldat= n
  incx=inc
  incy=inc

  call dgemv("N", M, N, ALPHA,  A,  LDA,  X,  INCY, BETA, Y, INCY)
  t0=seconds();
  t0=seconds();

  call fapp_start("dgemv1000",1,0)
  do i = 1, 1000
     call dgemv("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
  enddo
  call fapp_stop("dgemv1000",1,0)
  
  t1=(seconds()-t0)/dble(1000)


!  t0=seconds();
!  do i = 1, 100
!     call dgemv("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
!  enddo
!  t2=(seconds()-t0)/dble(100)
!  t0=seconds(); call dgemv("T", M, N, ALPHA,  A,  LDAT,  X,  INCX, BETA, Y, INCY); t2=seconds()-t0

end

!-------------------------------------------------------------------------------
subroutine sgemv_time(m,n,t1,t2, inc)
  implicit none
  integer, parameter :: imax=20000
  integer, intent(in) :: m, n, inc
  real(4) :: a(imax,imax), x(imax), y(imax)
  real(4) :: alpha, beta
  integer :: lda, ldat, incx, incy,i
  real(8) :: t0, t1, t2
  real(8), external :: seconds

  alpha = 2.0
  beta  = 1.0
  lda = m
  ldat= n
  incx=inc
  incy=inc

  call sgemv("N", M, N, ALPHA,  A,  LDA,  X,  INCX, BETA, Y, INCY)
  t0=seconds();
  do i = 1, 1000
     call sgemv("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
  enddo
  t1=(seconds()-t0)/dble(1000)


!  t0=seconds();
!  do i = 1, 100
!     call sgemv("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
!  enddo
!  t2=(seconds()-t0)/dble(100)

!  t0=seconds(); call sgemv("T", M, N, ALPHA,  A,  LDAT,  X,  INCX, BETA, Y, INCY); t2=seconds()-t0

end

!-------------------------------------------------------------------------------
subroutine hgemv_time(m,n,t1,t2, inc)
  implicit none
  integer, parameter :: imax=20000
  integer, intent(in) :: m, n, inc
  real(2) :: a(imax,imax), x(imax), y(imax)
  real(2) :: alpha, beta
  integer :: lda, ldat, incx, incy, i
  real(8) :: t0, t1, t2
  real(8), external :: seconds

  alpha = 2.0
  beta  = 1.0
  lda = m
  ldat= n
  incx=inc
  incy=inc

  call fjblas_gemv_r16("N", M, N, ALPHA,  A,  LDA,  X,  INCY, BETA, Y, INCY)
  t0=seconds()
  do i = 1, 1000
     call fjblas_gemv_r16("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
  enddo
  t1=(seconds()-t0)/dble(1000)

!  t0=seconds()
!  do i = 1, 100
!     call fjblas_gemv_r16("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
!  enddo
!  t2=(seconds()-t0)/dble(100)
!  t0=seconds(); call dgemv("T", M, N, ALPHA,  A,  LDAT,  X,  INCX, BETA, Y, INCY); t2=seconds()-t0

end

!-------------------------------------------------------------------------------
subroutine zgemv_time(m,n,t1,t2, inc)
  implicit none
  integer, parameter :: imax=20000
  integer, intent(in) :: m, n, inc
  complex(8) :: a(imax,imax), x(imax), y(imax)
  complex(8) :: alpha, beta
  integer :: lda, ldat, incx, incy,i
  real(8) :: t0, t1, t2
  real(8), external :: seconds

  alpha = 2.0
  beta  = 1.0
  lda = m
  ldat= n
  incx=inc
  incy=inc

  call zgemv("N", M, N, ALPHA,  A,  LDA,  X,  INCY, BETA, Y, INCY)
  t0=seconds();
  do i = 1, 1000
     call zgemv("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
  enddo
  t1=(seconds()-t0)/dble(1000)


!  t0=seconds();
!  do i = 1, 1000
!     call zgemv("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
!  enddo
!  t2=(seconds()-t0)/dble(1000)
!  t0=seconds(); call dgemv("T", M, N, ALPHA,  A,  LDAT,  X,  INCX, BETA, Y, INCY); t2=seconds()-t0

end


!-------------------------------------------------------------------------------
subroutine cgemv_time(m,n,t1,t2, inc)
  implicit none
  integer, parameter :: imax=20000
  integer, intent(in) :: m, n, inc
  complex(4) :: a(imax,imax), x(imax), y(imax)
  complex(4) :: alpha, beta
  integer :: lda, ldat, incx, incy,i
  real(8) :: t0, t1, t2
  real(8), external :: seconds

  alpha = 2.0
  beta  = 1.0
  lda = m
  ldat= n
  incx=inc
  incy=inc

  call cgemv("N", M, N, ALPHA,  A,  LDA,  X,  INCY, BETA, Y, INCY)
  t0=seconds();
  do i = 1, 1000
     call cgemv("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
  enddo
  t1=(seconds()-t0)/dble(1000)


!  t0=seconds();
!  do i = 1, 1000
!     call cgemv("N", M, N, ALPHA,  A,  LDA ,  X,  INCX, BETA, Y, INCY)
!  enddo
!  t2=(seconds()-t0)/dble(1000)
!  t0=seconds(); call dgemv("T", M, N, ALPHA,  A,  LDAT,  X,  INCX, BETA, Y, INCY); t2=seconds()-t0

end


!-------------------------------------------------------------------------------
real(8) function seconds() ! returns wall clock seconds
  implicit none
  real(8)       :: count_to_seconds
  integer(8)    :: count, count_rate
  logical, save :: initialized = .false.
  if (.not. initialized) then
     call system_clock(count, count_rate)
     count_to_seconds = 1.0_8 / real(count_rate, kind = 8)
  endif
  call system_clock(count)
  seconds = count * count_to_seconds
end

